#define _CLIENT_C_
#include <isdn_client.h>




/****************************************************************************
 *
 * In der Fkt. eval_message findet das EventHandling der einkommenden
 * Messages statt. Von Hier aus muessen die einzelnen Fenster bedient
 * werden.
 */

static	int eval_message (socket_queue *sock)
{
	int    Msg = sock->msg, kanal;
	CALL* Info = NULL;

	switch(sock->waitstatus)
	{
		case WF_ACC:
			switch (Msg)
			{
				case MSG_ANN_ACC:
					sock->servtyp = stoi(sock->msgbuf.buf,_MSG_2B);
					sock->waitstatus = WF_NOTHING;
					break;
				
				case MSG_ANN_REJ:
					/* Meldung: nicht authorisierter Zugriff auf Server */
					isdn_error (1);
					break;

				default:
					/* Meldung: Unbekannter Message-Typ Msg */
					fprintf    (stderr, isdn_error_get (2));
					break;
			}
			break;

		default:
			switch (Msg)
			{
				case MSG_CALLER:
					/* Eingabe eines Neuen Benutzers sock->msgbuf */
					break;
				
				case MSG_WHO_IS:
					/* Eingabe eines Neuen Benutzers sock->msgbuf */
					isdn_new_caller_display (sock);
					break;
				
				case MSG_SERVER:
					/* Eingabe eines Neuen Benutzers sock->msgbuf */
					isdn_prot (sock);
					break;
				
				case MSG_CALL_INFO:
					switch (kanal = Set_Info_Struct(&Info,sock->msgbuf.buf)){
					  case	NO_MEMORY:
					  	return NO_MEMORY;
					  default:
					  	isdn_list_update (kanal, Info); break;
					}
					break;

				default:
					/* Meldung: Unbekannter Message-Typ Msg */
					break;
			}
			break;
	}

	return 0;
}

/****************************************************************************/


static int start_connection (char *server, int port)
{
	int sock;
        socket_queue *socket = NULL;
	struct passwd *pw;

	if ((sock = client_connect(server,port)) < 0)
		return sock;

	if ((pw = getpwuid(getuid())) == NULL)
		return -1;

	if (add_socket (&socket, sock))
		return NO_MEMORY;

	socket->msg = MSG_ANNOUNCE;
	msgcpy (socket, pw->pw_name, strlen (pw->pw_name) + 1);

	Write (socket);

	socket->waitstatus = WF_ACC;
	socket->eval = eval_message;
	isdn_add_connection  (socket);
	return 0;
}


int main (int argc, char *argv[])
{
 int		fehler;

 isdn_initialize (&argc, argv);
 switch          (fehler = start_connection (
		 argc > 1 ? argv[1] : "localhost",
		 argc > 2 ? atoi (argv[2]) : SERV_PORT))
 {
   case 0:
     break;

   default:     /* Fehler */
     fprintf    (stderr, isdn_error_get (3));
     return     (fehler);
 }
 isdn_main_loop	();
 return 0;
}
