/* $Id: tools.c,v 2.2.5 1996/03/28 20:29:16 akool Exp akool $
 *
 * ISDN accounting for isdn4linux. (Utilities)
 *
 * Copyright 1995, 1996 by Andreas Kool (akool@Kool.f.EUnet.de)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: tools.c,v $
 * Revision 2.2.5  1996/03/28  20:29:16  akool
 * 1TR6 causes implemented
 *
 * Revision 2.23  1996/03/14  20:29:16  akool
 * Neue Routine i2a()
 *
 * Revision 2.17  1996/02/25  19:14:16  akool
 * Soft-Error in atom() abgefangen
 *
 * Revision 2.06  1996/02/07  18:49:16  akool
 * AVON-Handling implementiert
 *
 * Revision 2.01  1996/01/20  12:11:16  akool
 * Um Einlesen der neuen isdnlog.conf Felder erweitert
 * discardconfig() implementiert
 *
 * Revision 2.00  1996/01/10  20:11:16  akool
 *
 */


#define  PUBLIC /**/
#define  _TOOLS_C_

#include "tools.h"


char *CauseValue[] = { /* Cause Values According to Q.850 - shamelessly stolen from q931.c */
  "",
  "Unallocated (unassigned) number",
  "No route to specified transit network",
  "No route to destination",
  "Send special information tone",
  "Misdialled trunk prefix",
  "Channel unacceptable",
  "Channel awarded and being delivered in an established channel",
  "Preemption",
  "Preemption - circuit reserved for reuse",
  "",
  "",
  "",
  "",
  "",
  "",
  "Normal call clearing",
  "User busy",
  "No user responding",
  "No answer from user (user alerted)",
  "Subscriber absent",
  "Call rejected",
  "Number changed",
  "",
  "",
  "",
  "non-selected user clearing",
  "Destination out of order",
  "Invalid number format (address incomplete)",
  "Facility rejected",
  "Response to Status enquiry",
  "Normal, unspecified",
  "",
  "",
  "No circuit/channel available",
  "",
  "",
  "",
  "Network out of order",
  "Permanent frame mode connection out-of-service",
  "Permanent frame mode connection operational",
  "Temporary failure",
  "Switching equipment congestion",
  "Access information discarded",
  "Requested circuit/channel not available",
  "",
  "Precedence call blocked",
  "Resource unavailable, unspecified",
  "",
  "Quality of service unavailable",
  "Requested facility not subscribed",
  "",
  "",
  "Outgoing calls barred within CUG",
  "",
  "Incoming calls barred within CUG",
  "",
  "Bearer capability not auhorized",
  "Bearer capability not presently available",
  "",
  "",
  "",
  "Inconsistency in designated outgoing access information and subscriber class",
  "Service or option not available, unspecified",
  "",
  "Bearer capability not implemented",
  "Channel type not implemented",
  "Requested facility not implemented",
  "Only restricted digital information bearer capability is available",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "Service or option not implemented",
  "",
  "Invalid call reference value",
  "Identified channel does not exist",
  "A suspended call exists, but this call identity does not",
  "Call identity in use",
  "No call suspended",
  "Call having the requested call identity has been cleared",
  "User not member of CUG",
  "Incompatible destination",
  "",
  "Non-existent CUG",
  "Invalid transit network selection",
  "",
  "",
  "",
  "Invalid message, unspecified",
  "Mandatory information element is missing",
  "Message type non-existent or not implemented",
  "Message not compatible with call state or message type non-existent or not implemented",
  "Information element/parameter non-existent or not implemented",
  "Invalid information element contents",
  "Message not compatible with call state",
  "Recovery on timer expiry",
  "Parameter non-existent or not implemented - passed on",
  "",
  "",
  "",
  "",
  "",
  "",
  "Message with unrecognized parameter discarded",
  "Protocol error, unspecified",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "Interworking, unspecified",
};


char *Months[12] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
       	    	     "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };


static char proto[] = "                   0,000000000";
static int  cnf;


time_t atom(register char *p)
{
  register char     *p1 = p;
  auto 	   struct tm tm;


#ifdef DEBUG_1
  if (strlen(p) < 20) {
    print_msg(PRT_DEBUG_GENERAL, " DEBUG> Huch? atom(``%s'')\n", p);
    return((time_t)0);
  } /* if */
#endif

  tm.tm_mon = 0;

  while ((tm.tm_mon < 12) && memcmp(p1, Months[tm.tm_mon], 3)) tm.tm_mon++;

  p1 += 4;
  p = p1 + 2;

  *p = 0;

  day = tm.tm_mday = atoi(p1);

  p1 += 3;
  p = p1 + 2;
  *p = 0;
  tm.tm_hour = atoi(p1);

  p1 = ++p;
  p += 2;
  *p = 0;
  tm.tm_min = atoi(p1);

  p1 = ++p;
  p += 2;
  *p = 0;
  tm.tm_sec = atoi(p1);

  p1 = ++p;
  p += 4;
  *p = 0;

  tm.tm_year = atoi(p1 + 2);

#ifdef DEBUG_1
  if (tm.tm_year < 1995) {
    print_msg(PRT_DEBUG_GENERAL, " DEBUG> Huch? atom(): year=%d\n", tm.tm_year);
    return((time_t)0);
  } /* if */
#endif

  tm.tm_wday = tm.tm_yday;
  tm.tm_isdst = -1;

  return(mktime(&tm));
} /* atom */


static int createDB(char *fn, int force)
{
  register int         f;
  auto 	   char        s[BUFSIZ];
  auto 	   struct stat statbuf;


  sprintf(s, "%s/%s.dir", CONFDIR, fn);

  if (force || stat(s, &statbuf)) {
    if ((f = open(s, O_CREAT | O_TRUNC | O_RDWR, 0666)) >= 0) {
      close(f);

      sprintf(s, "%s/%s.pag", CONFDIR, fn);

      if ((f = open(s, O_CREAT | O_TRUNC | O_RDWR, 0666)) >= 0) {
        close(f);

      	return(1);
      } /* if */
    } /* if */
  } /* if */

  return(0);
} /* createDB */


static int openDB(char *fn)
{
  auto char s[BUFSIZ];


  sprintf(s, "%s/%s", CONFDIR, fn);
  dbm = dbm_open(s, O_RDWR | O_CREAT, 0666);
  return((dbm == (DBM *)NULL) ? -1 : 0);
} /* dbminit */


static void closeDB()
{
  if (dbm != (DBM *)NULL) {
    dbm_close(dbm);
    dbm = (DBM *)NULL;
  } /* if */
} /* dbmclose */


static void insertDB(char *num, char *area)
{
  key.dsize = strlen(num);
  key.dptr  = num;

  data.dsize = strlen(area) + 1;
  data.dptr = area;

  if (dbm_store(dbm, key, data, DBM_INSERT)) {
    fprintf(stderr, "\n%s: WARNING: Duplicate Entry ``%s'' in AVON in Line %d, ignored\n", myname, num, ln);

    data = dbm_fetch(dbm, key);

    fprintf(stderr, "%s: WARNING: Can't be ``%s'' and ``%s''!\n", myname, area, data.dptr);
    fprintf(stderr, "        <- Reading AVON, please wait ...");
  } /* if */
} /* insertDB */


#ifdef DEVEL
static void writeAVON()
{
  auto 	   char  s[BUFSIZ];
  auto 	   FILE *f;


  sprintf(s, "%s/%s.new", CONFDIR, AVON);

  if ((f = fopen(s, "w")) != (FILE *)NULL) {
    for (key = dbm_firstkey(dbm); key.dptr != NULL; key = dbm_nextkey(dbm)) {
      strcpy(s, key.dptr);
      *(s + key.dsize) = 0;
      data = dbm_fetch(dbm, key);
      fprintf(f, "%s:%s\n", s, data.dptr);
    } /* for */

    fclose(f);
  } /* if */
} /* writeAVON */
#endif


static void readAVON(char *fn)
{
  register char *p, *p1;
  auto 	   char  s[BUFSIZ];
  auto 	   FILE *f;


  ln = 0;

  if ((f = fopen(fn, "r")) != (FILE *)NULL) {

    fprintf(stderr, "        <- Reading AVON, please wait ...");

    while (fgets(s, BUFSIZ, f) != NULL) {

      ln++;

      if ((*s != '#') && (*s != '\n')) {

        if ((p = strchr(s, '\n'))) {
          *p = 0;

          if (*(p - 1) == '\r') /* I *hate* DOS! */
            *(--p) = 0;

          while (*--p == ' ')
            *p = 0;
        } /* if */

        if ((p = strchr(s, ':'))) { /* "avon.txt" Format */
          *p = 0;

          if (!(ln % 50))
            fprintf(stderr, "\r%s", s);

          insertDB(s, p + 1);
        }
        else if (*s == 'D') { /* "avon.uisdn" Format */
          if ((p = p1 = strchr(s, '+'))) {
            p -= 7;
            *p = 0;

            if ((p = strchr(p1, '-')))
              *p = 0;

            if (!(ln % 50))
              fprintf(stderr, "\r%s", p1 + 4);

            while ((p = strchr(s + 6, '_')))
              *p = ' ';

  	    insertDB(p1 + 4, s + 6);
          } /* if */
        }
        else
          fprintf(stderr, "%s: WARNING: Syntax error in AVON at Line %d, ignored\n", myname, ln);
      } /* if */
    } /* while */

    fclose(f);
    fprintf(stderr, "\n");
  } /* if */
} /* readAVON */


static char *NextItem(char *Line)
{
  register char *p;


  while (*Line && (*Line != ' ') && (*Line != '\t'))
    Line++;

  p = Line;

  while ((*Line == ' ') || (*Line == '\t'))
    Line++;

  *p = 0;

  return(Line);
} /* NextItem */


void readconfig(char *myname)
{
  register char *p;
  register int	 i;
  auto     FILE *f;
  auto     char  s[BUFSIZ];
  auto 	   char *num, *who, *zone, *flags, *time, *infoarg;


  mymsns   = 3;
  myprefix = strdup("");
  hangup   = strdup("");
  aocd     = strdup("");
  currency = strdup("");
  knowns   = retnum = 0;
  hangup   = aocd = NULL;


  sprintf(s, "%s/%s", CONFDIR, CONFFILE);

  if ((f = fopen(s, "r")) != (FILE *)NULL) {

    while (fgets(s, BUFSIZ, f) != NULL) {

      ln++;

      if ((*s != '#') && (*s != '\n')) {

        if ((p = strchr(s, '\n'))) {
          *p = 0;

          while (*--p == ' ')
            *p = 0;
        } /* if */

        if (!memcmp(s, "MYMSNS=", 7))
          mymsns = atoi(s + 7);
        else if (!memcmp(s, "MYPREFIX=", 9)) {
          free(myprefix);
          myprefix = strdup(s + 9);
        }
        else if (!memcmp(s, "HANGUP=", 7)) {
          free(hangup);
          hangup = strdup(s + 7);
        }
        else if (!memcmp(s, "AOCD=", 5)) {
          free(aocd);
          aocd = strdup(s + 5);
        }
        else if (!memcmp(s, "CURRENCY=", 9)) { /* CURRENCY=<factor>,<currency> */
          if ((p = strchr(s, ','))) {
            *p = 0;
            currency_factor = atof(s + 9);
            currency = strdup(p + 1);
          }
          else
	    fprintf(stderr, "%s: WARNING: Syntax error in `CURRENCY' in Line %d, ignored\n", myname, ln);

        }
	else {

	  num     = s;
	  who	  = NextItem(num);
	  zone    = NextItem(who);
	  flags   = NextItem(zone);
	  time    = NextItem(flags);
	  infoarg = NextItem(time);

          if (*num && *who) {
            known = realloc(known, sizeof(KNOWN *) * knowns + 1);

  	    if ((known[knowns] = (KNOWN *)malloc(sizeof(KNOWN)))) {

  	      known[knowns]->num  = strdup(num);
  	      known[knowns]->who  = strdup(who);
  	      known[knowns]->zone = atoi(zone);

              known[knowns]->flags = 0;

              while (*flags) {
                switch (*flags) {
       	          case 'I' : known[knowns]->flags |= RING_INCOMING; break;
       	          case 'O' : known[knowns]->flags |= RING_OUTGOING; break;
       	          case 'C' : known[knowns]->flags |= RING_CONNECT ; break;
       	          case 'R' : known[knowns]->flags |= RING_RING    ; break;
       	          case 'K' : known[knowns]->flags |= RING_KILL    ; break;
       	          case 'P' : known[knowns]->flags |= RING_PROVIDER; break;
       	          case 'S' : known[knowns]->flags |= RING_AOCD;     break;
       	          case 'A' : known[knowns]->flags |= RING_SPEAK;    break;

                   default : fprintf(stderr, "%s: WARNING: Unknown flag ``%c'' in Line %d, ignored\n", myname, *flags, ln);
                } /* switch */

                flags++;
              } /* while */

              known[knowns]->time    = strdup(time);
              known[knowns]->infoarg = strdup(infoarg);

  	      known[knowns]->dur[CALLING] = known[knowns]->dur[CALLED] = 0.0;
  	      known[knowns]->eh = 0;
  	      known[knowns]->usage[DIALOUT] = known[knowns]->usage[DIALIN] = 0;
  	      known[knowns]->dm = 0.0;

              knowns++;
	    }
            else {
  	      fprintf(stderr, "%s: WARNING: Out of memory in Line %d\n", myname, ln);
              break;
            } /* else */
          }
          else {
  	    fprintf(stderr, "%s: WARNING: Syntax error in Line %d, ignored\n", myname, ln);
            break;
          } /* else */
	} /* else */
      } /* if */
    } /* while */

    fclose(f);

    if (*myprefix) {
      for (i = 0; i < mymsns; i++) {
        sprintf(s, "%s%s", myprefix, known[i]->num);
        free(known[i]->num);
  	known[i]->num  = strdup(s);
      } /* for */
    }
    else
      fprintf(stderr, "%s: WARNING: Missing entry ``MYPREFIX''\n", myname);

  }
  else
    fprintf(stderr, "%s: WARNING: Can't open ``%s''\n", myname, s);


  sprintf(s, "%s/%s", CONFDIR, AVON);

  if (!access(s, R_OK)) {
    if (createDB(AVON, 0) && !openDB(AVON))
      readAVON(s);
    else
      (void)openDB(AVON);
  } /* if */
} /* readconfig */


void discardconfig(void)
{
  register int i;


  for (i = 0; i < knowns; i++) {
    free(known[i]->num);
    free(known[i]->who);
    free(known[i]->time);
    free(known[i]->infoarg);

    free(known[i]);
  } /* for */

  free(known);

  free(hangup);
  free(aocd);
  free(currency);
  free(myprefix);

  closeDB();
} /* discardconfig */


static char *cclass(register char *p, register int sub)
{
  register int c, d, not, found;


  if ((not = (*p == NOT)))
    p++;

  found = not;

  do {
    if (!*p)
      return(NULL);

    c = *p & QCMASK;

    if (p[1] == '-' && p[2] != ']') {
      d = p[2] & QCMASK;
      p++;
    }
    else
      d = c;

    if ((c == sub) || ((c <= sub) && (sub <= d)))
      found = !not;
  } while (*++p != ']');

  return(found ? p + 1 : NULL);
} /* cclass */


int match(register char *s, register char *p)
{
  register int sc, pcc;


  if (!*s || !*p)
    return(0);

  while ((pcc = *p++ & QCMASK)) {
    sc = *s++ & QMASK;

    switch (pcc) {
      case '[' : if (!(p = cclass(p, sc)))
	           return(0);
	         break;

      case '?' : if (!sc)
	           return(0);
	         break;

      case '*' : s--;
	         do {
	           if (!*p || match(s, p))
	             return(1);
	         } while (*s++);
	         return(0);

      default  : if (sc != (pcc &~QUOTE))
	           return(0);
    } /* switch */
  } /* while */

  return(!*s);
} /* match */


char *num2nam(char *num)
{
  register int i;


  if (*num) {
    for (i = 0; i < knowns; i++)
      if (match(num, known[i]->num)) {
        if (++retnum == MAXRET)
          retnum = 0;

        cnf = i;
        return(strcpy(retstr[retnum], known[i]->who));
      } /* if */
  } /* if */

  cnf = -1;
  return("");
} /* num2nam */


char *double2str(double n, int l, int d, int flags)
{
  register char *p, *ps, *pd, *px;
  auto     int   decpt, sign, dec, dp;
  auto     char  buf[BUFSIZ];


  if (++retnum == MAXRET)
    retnum = 0;

  p = retstr[retnum] + l + 1;
  *p = 0;

  dec = d ? d : -1;
  dp = l - dec;

  *buf = '0';
  memcpy(buf + 1, ecvt(n, DIGITS, &decpt, &sign), DIGITS);

  ps = buf;
  px = ps + decpt + d;

  if (px >= buf) {
    int rfound = 0;
    pd = px + 1;

    if (*pd > '4') {
      pd++;
      rfound++;
    } /* if */

    if (rfound) {
      while (pd > px)
	if (*pd >= '5') {
	  pd--;
	  while (*pd == '9')
	    *pd-- = '0';
	  *pd += 1;
	}
	else
	  pd--;
    } /* if */

    if (*buf == '1')
      decpt++;
    else
      ps++;

    if ((dp < 2 + sign) || ((decpt ? decpt : 1) + sign) >= dp) {
      memset(retstr[retnum] + 1, '*', *retstr[retnum] = l);
      return(retstr[retnum] + 1);
    } /* if */

  } /* if */

  memcpy(retstr[retnum] + 1, proto + 21 - l + dec, *retstr[retnum] = l);

  if (!((decpt < 0) && ((dec + decpt) <= 0))) {
    pd = retstr[retnum] + dp - decpt;

    if (sign) {
      if (decpt > 0)
	*(pd - 1) = '-';
      else
	*(retstr[retnum] + dp - 2) = '-';
    } /* if */

    while (decpt-- > 0)
      *pd++ = *ps++;

    pd++; /* skip comma */

    while (d-- > 0)
      *pd++ = *ps++;
  } /* if */

  if (flags & DEB) {
    p = retstr[retnum] + 1;

    while (*p == ' ')
      p++;

    return(p);
  } /* if */

  return(retstr[retnum] + 1);

} /* double2str */


char *double2clock(double n)
{
  auto int x, h, m, s;


  if (++retnum == MAXRET)
    retnum = 0;


  if (n <= 0.0)
    sprintf(retstr[retnum], "        ");
  else {
#if 0
    x = floor(n);
#else
    x = (int)n;
#endif

    h = (int)(x / 60 / 60);
    x %= 60 * 60;
    m = (int)(x / 60);
    s = (int)(x % 60);

#if 0
    sprintf(retstr[retnum], "%2d:%02d:%02d.%02d", h, m, s,
                                                  (int)((n - x) * 100));
#else
    sprintf(retstr[retnum], "%2d:%02d:%02d", h, m, s);
#endif
  } /* else */

  return(retstr[retnum]);
} /* double2clock */


char *vnum(char *num, char *vorwahl, char *rufnummer, char *alias, char *area, int *confentry)
{
  register int  l = strlen(num);


  if (++retnum == MAXRET)
    retnum = 0;

  *vorwahl = *rufnummer = *alias = *area = 0;
  *confentry = -1;

  if (!l) {       /* keine Meldung von der Vst (Calling party number fehlt) */
    sprintf(retstr[retnum], "?");
    return(retstr[retnum]);
  } /* if */

  strcpy(alias, num2nam(num));

  if (cnf > -1) {                    /* Alias gefunden! */
    *confentry = cnf;
    strcpy(retstr[retnum], alias);
    return(retstr[retnum]);
  } /* if */

  if (!memcmp(num, "0130", 4)) {      /* Well known's prefix? */
    strcpy(area, "Toll-free");
    l = 4;
  }
  else if (!memcmp(num, "0190", 4)) {
    strcpy(area, "Service 190");
    l = 4;
  }
  else if (!memcmp(num, "019", 3)) {
    strcpy(area, "Service 19");
    l = 3;
  }
  else if (!memcmp(num, "0171", 4)) {
    strcpy(area, "Mobilfunknetz D1");
    l = 4;
  }
  else if (!memcmp(num, "0172", 4)) {
    strcpy(area, "Mobilfunknetz D2");
    l = 4;
  }
  else if (!memcmp(num, "0177", 4)) {
    strcpy(area, "Mobilfunknetz E-Plus");
    l = 4;
  }
  else if (!memcmp(num, "01188", 5)) {
    strcpy(area, "Auskunft Inland");
    l = 5;
  } /* else */

  if (!*area && (dbm != NULL) && (l > 4)) {
    key.dptr = num;

    l -= 3;

    while (l > 1) {
      key.dsize = l;
      data = dbm_fetch(dbm, key);

      if (data.dptr != NULL) {
        strcpy(area, data.dptr);
        break;
      } /* if */

      l--;
    } /* while */
  }
  else
    l = 0;

  if (l > 1) {
    strncpy(vorwahl, num, l);
    strcpy(rufnummer, num + l);
  }
  else {
    strcpy(rufnummer, num);
    l = 0;
  } /* else */

  if (l)
    sprintf(retstr[retnum], "%s/%s, %s", vorwahl, rufnummer, area);
  else if (*area)
    sprintf(retstr[retnum], "%s, %s", rufnummer, area);
  else
    strcpy(retstr[retnum], rufnummer);

  return(retstr[retnum]);
} /* vnum */


char *i2a(int n, int l, int base)
{
  static   char  Digits[] = "0123456789abcdef";
  register char *p;
  register int	 dot = 0;


  if (++retnum == MAXRET)
    retnum = 0;

  p = retstr[retnum] + RETSIZE - 1;
  *p = 0;

  while (n || (l > 0)) {
    if (n) {
      *--p = Digits[n % base];
      n /= base;
    }
    else
      *--p = '0';

    l--;

    dot++;

    if (!(dot % 8))
      *--p = ' ';
    else if (!(dot % 4))
      *--p = '.';
  } /* while */

  return(((*p == ' ') || (*p == '.')) ? p + 1 : p);
} /* i2a */


char *tr6cause(int cause)
{
  register int  i;
  static   char s[BUFSIZ];

  typedef struct {
    int   nr;
    char *descr;
  } Cause1TR6;

  static Cause1TR6 cause_1tr6[] = {
    {0x00, "Normal Call Clearing"},
    {0x80, "Normal Call Clearing"},
    {0x81, "Invalid Call Reference"},
    {0x83, "Bearer Service Not Implemented"},
    {0x87, "Caller Identity unknown"},
    {0x88, "Caller Identity in Use"},
    {0x89, "No Channels available"},
    {0x8a, "No Channels available"},
    {0x90, "Facility Not Implemented"},
    {0x91, "Facility Not Subscribed"},
    {0xa0, "Outgoing calls barred"},
    {0xa1, "User Access Busy"},
    {0xa2, "Negative GBG"},
    {0xa3, "Unknown  GBG"},
    {0xa5, "No SPC known"},
    {0xb5, "Destination not obtainable"},
    {0xb8, "Number changed"},
    {0xb9, "Out Of Order"},
    {0xba, "No User Response"},
    {0xbb, "User Busy"},
    {0xbd, "Incoming Barred"},
    {0xbe, "Call Rejected"},
    {0xd8, "Invalid destination address"},
    {0xd9, "Network Congestion"},
    {0xda, "Remote User initiated"},
    {0xf0, "Local Procedure Error"},
    {0xf1, "Remote Procedure Error"},
    {0xf2, "Remote User Suspend"},
    {0xf3, "Remote User Resumed"},
    {0xff, "User Info Discarded"},
    {-1, ""}
  };

  for (i = 0; cause_1tr6[i].nr != -1 ; i++)
    if (cause_1tr6[i].nr == cause) {
      sprintf(s, "%s", cause_1tr6[i].descr);
      return(s);
    } /* if */

  sprintf(s, "Unknown cause type : 0x%02x", cause);
  return(s);
} /* 1tr6cause */
